<?php
	/*
	Data Table shortcode
	***************************/

	if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
	
	// add shortcode
	add_action('init' , 'wprsdt_shortcode_init');
	// enable shortcode in widget area
	add_filter('widget_text', 'do_shortcode');
	
	function wprsdt_shortcode_init() {
		add_shortcode( 'wprs-datatable' , 'wprsdt_display' );
	}
	
	
	add_action( 'wp', 'wprsdt_detect_shortcode' );
	/*
		load styles to head only if shortcode is used
		*/
	function wprsdt_detect_shortcode() {
		
		if (is_admin()) return;
		
		global $post;
		
		// get options
		$options = get_option('wprsdt_options');
		
    	if (is_single() || is_page()) {
			
			$pattern = get_shortcode_regex();

			if ( preg_match_all( '/'. $pattern .'/s', $post->post_content, $matches )
				&& array_key_exists( 2, $matches )
				&& in_array( 'wprs-datatable', $matches[2] ) )
			{
				// shortcode is being used
				// load scripts and styles
				add_action( 'wp_enqueue_scripts',	'wprsdt_add_styles' );
				add_action( 'wp_enqueue_scripts',	'wprsdt_add_scripts' );
				add_action( 'wp_head',				'wprsdt_tablesorter_script' );
			}
			
			// load styles & scripts if is enabled
			// within plugin settings
			//if (isset($options['wprsdt_chk_table_styles']) != '')		add_action( 'wp_enqueue_scripts',	'wprsdt_add_styles' );
			//if (isset($options['wprsdt_chk_table_scripts']) != '')		add_action( 'wp_enqueue_scripts',	'wprsdt_add_scripts' );
			//if (isset($options['wprsdt_chk_table_scripts']) != '')      add_action( 'wp_head',				'wprsdt_tablesorter_script' );
			
			// Post the post
			do_action('wp_insert_post', 'wp_insert_post');
		
		}
		
		// load styles & scripts if is enabled
			// within plugin settings
			if (isset($options['wprsdt_chk_table_styles']) != '')		add_action( 'wp_enqueue_scripts',	'wprsdt_add_styles' );
			if (isset($options['wprsdt_chk_table_scripts']) != '')		add_action( 'wp_enqueue_scripts',	'wprsdt_add_scripts' );
			if (isset($options['wprsdt_chk_table_scripts']) != '')      add_action( 'wp_head',				'wprsdt_tablesorter_script' );
			
	}
	
	//----------------------------------------------
	// start display shortcode
	function wprsdt_display($atts, $content = null) {
		//$img ='';
		extract(shortcode_atts(array(
                "table_name" => '',				// add table itemprop about
				"num" => '10',					// number of posts, default = 10
				"order" => 'meta_value_num',	// order, default = meta_value_num (rating, rank)
                "cpt" => 'post',				// custom post type
				"type" => 'rating',				// rating/percentage/votes/aggregate, default = rating
				"cat" => '',					// categories (32, 65, 876)
				'parent' => false, 				// id or parent page, to display child pages
				'taxonomy' => false,			// taxonomy name
				'tax_term' => false,			// taxonomy terms "term1, term2"
				"rank" => '',					// enable/disable rank
				"name" => '',					// enable/disable name
				"name_title" => 'Name', 		// edit table header, default = Name
				"images" => '',					// enable/disable images
				"images_title" => 'Photo', 		// edit table header, default = Photo
				"width" => 160,					// image width, default = 160
				"height" => 100,				// image height, default = 100
				"summary" => '',				// enable/disable summary
				"price" => '',					// enable/disable price
				"rating" => '',					// enable/disable rating
				"action" => '',					// enable/disable call to action
				"min" => '',					// set minimum user reviews to show (for user aggregate reviews)
        ), $atts));
		
		global $wp, $post, $wprs_prefix;
		// get plugin options
		$options = get_option('wprsdt_options');
		// get WP Reviews plugin options
		$wpr_options = get_option('wprs_options');
		
		// get currency and currency sympol
		//if (isset($wpr_options['wprs_currency']) != '') {$currency = $wpr_options['wprs_currency'];} else {$currency = 'USD';}
		//$currency_sympol = wprs_get_currency_symbol($currency);
		
		$wprsdt_rank = 1; // set rank
		
		$reviews_table = '';
		$wprsdt_rating = '';
		$wprsdt_summary = '';
		$wprsdt_price = '';
		$review_url = '';
		$url = '';
		
		// custom post type
		if(isset($cpt)) {$ptype = $cpt;} else {$ptype = 'post';}
		// set review type (author/user) default is: editor
		//if (isset($type)) {$reviewtype = $type;} else {$reviewtype = 'editor';}
			
		$reviewtype = $type;
								
		// query based on type
		if ($type == 'rating') {
			$icon_type = '<span class="icon-user"></span> '.__('Editor', 'wprs-datatables').' ';
			$r = new WP_Query(array(	
									'post_type' => $ptype,
									'posts_per_page' => $num,
									'no_found_rows' => true,
									'post_status' => 'publish',
									'meta_key'=> $wprs_prefix.'star_rating',
									'cat' => $cat,
									'post_parent' => $parent,
									'taxonomy' => $taxonomy,
									'tax_term' => $tax_term,
									'ignore_sticky_posts' => true,
									'orderby'=> $order,
									'order'=> 'DESC',
								));
		}
		
		if ($type == 'percentage') {
			$icon_type = '<span class="icon-user"></span> '.__('Editor', 'wprs-datatables').' ';
			$r = new WP_Query(array(	
									'post_type' => $ptype,
									'posts_per_page' => $num,
									'no_found_rows' => true,
									'post_status' => 'publish',
									'meta_key'=> $wprs_prefix.'slider_percentage',
									'cat' => $cat,
									'post_parent' => $parent,
									'taxonomy' => $taxonomy,
									'tax_term' => $tax_term,
									'ignore_sticky_posts' => true,
									'orderby'=> $order,
									'order'=> 'DESC',
								));
		}
		
		if ($type == 'votes') {
			$icon_type = '<span class="icon-user"></span> '.__('User', 'wprs-datatables').' ';
			$r = new WP_Query(array(	
									'post_type' => $ptype,
									'posts_per_page' => $num,
									'no_found_rows' => true,
									'post_status' => 'publish',
									'meta_key'=> $wprs_prefix.'user_rating',
									'cat' => $cat,
									'post_parent' => $parent,
									'taxonomy' => $taxonomy,
									'tax_term' => $tax_term,
									'ignore_sticky_posts' => true,
									'orderby'=> $order,
									'order'=> 'DESC',
								));
		}
		
		if ($type == 'aggregate') {
			$icon_type = '<span class="icon-user"></span> '.__('User', 'wprs-datatables').' ';
			$r = new WP_Query(array(	
									'post_type' => $ptype,
									'posts_per_page' => $num,
									'no_found_rows' => true,
									'post_status' => 'publish',
									'meta_key'=> $wprs_prefix.'userrating_average',
									'meta_query' => array(
										array(
											'key'     => $wprs_prefix.'userrating_average',
											'value'   => '0',
											'compare' => '!=',
										),
									),
									'cat' => $cat,
									'post_parent' => $parent,
									'taxonomy' => $taxonomy,
									'tax_term' => $tax_term,
									'ignore_sticky_posts' => true,
									'orderby'=> $order,
									'order'=> 'DESC',
								));
		} 
		
		if ($r->have_posts()) :
		
		// echo before
		// open main div
		//$reviews_table .= '<div id="wpr_table" class="table-responsive">';
		$reviews_table .= '<div id="wprs_table" itemscope itemtype="http://schema.org/Table">';
		
		// add table itemprop about
		if ($table_name != '') $reviews_table .= '<h2 itemprop="about">'.$table_name.'</h2>';

		// start table
		//$reviews_table .= '<table id="WPRTable" class="table tablesorter">';
		$reviews_table .= '<table id="wprs_datatables" class="display responsive no-wrap" cellspacing="0" width="100%">';
		
		$reviews_table .= '<thead>';
		$reviews_table .= '<tr>';
								if($rank !='no') $reviews_table .= '<th class="text_center">'.__('Rank', 'wprs-datatables').'</th>';
								if($images !='no') $reviews_table .= '<th class="text_center">'.__($images_title, 'wprs-datatables').'</th>';
								if($name !='no') $reviews_table .= '<th class="text_center">'.__($name_title, 'wprs-datatables').'</th>';
								if($summary !='no') $reviews_table .= '<th>'.__('Summary', 'wprs-datatables').'</th>';
								if($price !='no') $reviews_table .= '<th class="text_center">'.__('Price', 'wprs-datatables').'</th>';
								if($rating !='no') $reviews_table .= '<th class="text_center"><nobr>'.$icon_type . __('Rating', 'wprs-datatables').'</nobr></th>';
								if($action !='no') $reviews_table .= '<th class="text_center">'.__('Action', 'wprs-datatables').'</th>';
		$reviews_table .= '</tr>';
		$reviews_table .= '</thead>';
		
		$reviews_table .= '<tfoot>';
		$reviews_table .= '<tr>';
								if($rank !='no') $reviews_table .= '<th class="text_center">'.__('Rank', 'wprs-datatables').'</th>';
								if($images !='no') $reviews_table .= '<th class="text_center">'.__($images_title, 'wprs-datatables').'</th>';
								if($name !='no') $reviews_table .= '<th class="text_center">'.__($name_title, 'wprs-datatables').'</th>';
								if($summary !='no') $reviews_table .= '<th>'.__('Summary', 'wprs-datatables').'</th>';
								if($price !='no') $reviews_table .= '<th class="text_center">'.__('Price', 'wprs-datatables').'</th>';
								if($rating !='no') $reviews_table .= '<th class="text_center">'.$icon_type . __('Rating', 'wprs-datatables').'</th>';
								if($action !='no') $reviews_table .= '<th class="text_center">'.__('Action', 'wprs-datatables').'</th>';
		$reviews_table .= '</tr>';
		$reviews_table .= '</tfoot>';
		
		$reviews_table .= '<tbody>';
		
		while ($r->have_posts()) : $r->the_post();
		
		// get custom vaules
		$custom = get_post_custom();
		
		// get box template
		$template = array();
		if (function_exists('wprs_template')) $template = wprs_template();
		
		if ($type == 'rating') {
			if ($template['editor_star_rating_no_markup'] !='') $the_rating = $template['editor_star_rating_no_markup'];
		}
		
		if ($type == 'percentage') {
			if ($template['progressbar_editor'] !='') $the_rating = $template['progressbar_editor'];
		}
		
		if ($type == 'votes') {
			if ($template['user_star_rating'] !='') $the_rating = $template['user_star_rating'];
		}
		
		if ($type == 'aggregate') {
			if ($template['user_star_aggregate_raw'] !='') $the_rating = $template['user_star_aggregate_raw'];
		}
		
		// get post url
		$wprsdt_url = get_permalink($post->ID);
		
		// get name
		$wprsdt_name = (isset($template['name'])) ? '<h3><a href="'.$wprsdt_url.'" title="'.esc_attr(get_the_title()).'">'.$template['name'].'</a></h3>' : '';
		
		// get buttons
		if ((isset($custom[$wprs_prefix.'item_url'][0]))) {$review_url = $custom[$wprs_prefix.'item_url'][0];} else {$review_url = '';}	// get review url
		if (!empty($review_url)) {
			$button = '<a href="'.$review_url.'" class="ar_button ar_blue" title="" target="_blank" rel="nofollow"><nobr><span class="fa fa-icon-star"></span> '.__('Visit website', 'wprs').'</nobr></a>';} else {$button ='';}
		
		// check entry name
		if ((isset($custom[$wprs_prefix.'item_name'][0]))) {
			$wprsdt_name = '<a href="'.$wprsdt_url.'" title="'.esc_attr(get_the_title()).'"><nobr>'.$custom[$wprs_prefix.'item_name'][0].'</nobr></a>';
		} else {
			$wprsdt_name = '';
		}
		
		// get summary
		if ((isset($custom[$wprs_prefix.'item_description'][0]))) {
			$wprsdt_summary = wprsdt_short_content ($custom[$wprs_prefix.'item_description'][0], 100) . '... ';
			$wprsdt_summary .= '<a href="'.$wprsdt_url.'" title="'.esc_attr(get_the_title()).'">' . __('Read review',' wprs-datatables') . '</a>';
		} else {
			$wprsdt_summary = '';
		}
		
		// get price
		//if ((isset($custom[$wprs_prefix.'lowprice'][0]))) {$wprsdt_price = $custom[$wprs_prefix.'lowprice'][0];}
		//else {$wprsdt_price = '';}
		
		$wprsdt_price = (isset($template['price'])) ? $template['price'] : '';
		
		// check if WPRS is enabled on entry
		if ( wprs_is_enabled($post->ID) ) {
			
			// build table body
			$reviews_table .= '<tr class="spaceUnder" valign="middle">';
				if($rank !='no') $reviews_table .= '<td class="table_rank" valign="middle">'.$wprsdt_rank.'</td>';
				if($images !='no') $reviews_table .= '<td class="table_media" valign="middle">'.wprs_review_media_extend($post->ID, $width, $height).'</td>';
				if($name !='no') $reviews_table .= '<td class="table_name" valign="middle">'.$wprsdt_name.'</td>';
				//if($images !='no') $reviews_table .= '<td class="table_media" valign="middle">'.$template['media'].'</td>';
				if($summary !='no') $reviews_table .= '<td class="table_summary" valign="middle"><p>'.$wprsdt_summary.'</p></td>';
				if($price !='no') $reviews_table .= '<td class="table_price" valign="middle">'.$wprsdt_price.'</td>';
				if($rating !='no') $reviews_table .= '<td class="table_rating" valign="middle"><span style="display:none">'.$wprsdt_rating.'</span></d>'.$the_rating.'</td>';
				//if($action !='no') $reviews_table .= '<td class="table_action" valign="middle">'.$button.'</td>';
				if($action !='no') $reviews_table .= '<td class="table_action" valign="middle">'.$template['link'].'</td>';
			$reviews_table .= '</tr>';
		
			$wprsdt_rank = $wprsdt_rank +1;
		
		}
		
		endwhile;
		
		// close table
		$reviews_table .= '</tbody>';
		$reviews_table .= '</table>';
		
		$reviews_table .= '<div class="clr"></div>';
		// close main div
		$reviews_table .= '</div>';
		$reviews_table .= '<div class="clr"></div>';

		endif;
		
		// reset the global $the_post as this query will have stomped on it
		wp_reset_postdata();
		
		return $reviews_table;	
}

	
	// load styles
	function wprsdt_add_styles() {
	
		wp_register_style( 'wprs-datatables', WPRSDT_CSS_URL.'jquery.dataTables.min.css', array(), '1.0', 'all' );
		wp_register_style( 'wprs-datatables-bootstrap', WPRSDT_CSS_URL.'dataTables.bootstrap.css', array(), '1.0', 'all' );
		wp_register_style( 'wprs-datatables-responsive', WPRSDT_CSS_URL.'dataTables.responsive.css', array(), '1.0', 'all' );
		
		wp_enqueue_style( 'wprs-datatables' );
		wp_enqueue_style( 'wprs-datatables-bootstrap' );
		wp_enqueue_style( 'wprs-datatables-responsive' );
	
	}

	
	// load scripts
	function wprsdt_add_scripts() {
    	
		// register
		wp_register_script('wprs-datatables', WPRSDT_JS_URL.'jquery.dataTables.min.js', false, '1.0', false);
		wp_register_script('wprs-datatables-bootstrap', WPRSDT_JS_URL.'dataTables.bootstrap.js', false, '1.0', false);
		wp_register_script('wprs-datatables-responsive', WPRSDT_JS_URL.'dataTables.responsive.js', false, '1.0', false);
		
		// enqueue
		wp_enqueue_script( 'jquery' );
		wp_enqueue_script( 'wprs-datatables' );
		wp_enqueue_script( 'wprs-datatables-bootstrap' );
		wp_enqueue_script( 'wprs-datatables-responsive' );
	
	}
	

	// tablesorter script
	function wprsdt_tablesorter_script() {
		$options = get_option('wprsdt_options');
		?>
		<script type="text/javascript" language="javascript" class="init">
			jQuery(document).ready(function($) {
				$('#wprs_datatables').DataTable({
					<?php if (isset($options['wprsdt_chk_searching'])) echo '"searching":   false,'; ?>
					<?php if (isset($options['wprsdt_chk_paging'])) echo '"paging":   false,'; ?>
					<?php if (isset($options['wprsdt_chk_ordering'])) echo '"ordering":   false,'; ?>
					<?php if (isset($options['wprsdt_chk_info'])) echo '"info":   false,'; ?>
					"lengthMenu": [[5, 10, 25, 50, -1], [5, 10, 25, 50, "All"]],
					responsive: true
				});
			});
		</script>
        <?php
	}
	
	function wprsdt_short_content($string, $limit = 100) {
    	// return early if the string is already shorter than the limit
    	if(strlen($string) < $limit) {return $string;}

    	$regex = "/(.{1,$limit})\b/";
    	preg_match($regex, $string, $matches);
    	return $matches[1];
	}